.\"	$OpenBSD: mmap.2,v 1.41 2013/04/08 19:35:00 guenther Exp $
.\"	$NetBSD: mmap.2,v 1.5 1995/06/24 10:48:59 cgd Exp $
.\"
.\" Copyright (c) 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)mmap.2	8.1 (Berkeley) 6/4/93
.\"
.Dd $Mdocdate: April 8 2013 $
.Dt MMAP 2
.Os
.Sh NAME
.Nm mmap
.Nd map files or devices into memory
.Sh SYNOPSIS
.Fd #include <sys/types.h>
.Fd #include <sys/mman.h>
.Ft void *
.Fn mmap "void *addr" "size_t len" "int prot" "int flags" "int fd" "off_t offset"
.Sh DESCRIPTION
The
.Nm mmap
function causes the contents of
.Fa fd ,
starting at
.Fa offset ,
to be mapped in memory at the given
.Fa addr .
The mapping will extend at least
.Fa len
bytes, subject to page alignment restrictions.
.Pp
The
.Fa addr
argument describes the address where the system should place the mapping.
If the
.Dv MAP_FIXED
flag is specified, the allocation will happen at the specified address,
replacing any previously established mappings in its range.
Otherwise, the mapping will be placed at the available spot at
.Fa addr ;
failing that it will be placed "close by".
If
.Fa addr
is
.Dv NULL
the system can pick any address.
Except for
.Dv MAP_FIXED
mappings, the system will never replace existing mappings.
.Pp
The
.Fa len
argument describes the minimum amount of bytes the mapping will span.
Since
.Nm
maps pages into memory,
.Fa len
may be rounded up to hit a page boundary.
If
.Fa len
is 0, the mapping will fail with
.Er EINVAL .
.Pp
If an
.Fa fd
and
.Fa offset
are specified, the resulting address may end up not on a page boundary,
in order to align the page offset in the
.Fa addr
to the page offset in
.Fa offset .
.Pp
The protections (region accessibility) are specified in the
.Fa prot
argument by OR'ing the following values:
.Pp
.Bl -tag -width "PROT_WRITE  " -offset indent -compact
.It Dv PROT_EXEC
Pages may be executed.
.It Dv PROT_READ
Pages may be read.
.It Dv PROT_WRITE
Pages may be written.
.It Dv PROT_NONE
No permissions.
.El
.Pp
The
.Fa flags
parameter specifies the type of the mapped object, mapping options, and
whether modifications made to the mapped copy of the page are private
to the process or are to be shared with other references.
Sharing, mapping type, and options are specified in the
.Fa flags
argument by OR'ing the following values:
.Bl -tag -width MAP_FIXEDX
.It Dv MAP_ANON
Map anonymous memory not associated with any specific file.
The file descriptor used for creating
.Dv MAP_ANON
must currently be \-1 indicating no name is associated with the
region.
.It Dv MAP_FILE
Mapped from a regular file or character-special device memory.
(This is the default mapping type, and need not be specified.)
.It Dv MAP_FIXED
Demand that the mapping is placed at
.Fa addr ,
rather than having the system select a location.
.Fa addr ,
.Fa len
and
.Fa offset
(in the case of
.Fa fd
mappings)
must be multiples of the page size.
Existing mappings in the address range will be replaced.
Use of this option is discouraged.
.It Dv MAP_HASSEMAPHORE
Notify the kernel that the region may contain semaphores and that special
handling may be necessary.
.It Dv MAP_INHERIT
Permit regions to be inherited across
.Xr exec 3
system calls.
.It Dv MAP_PRIVATE
Modifications are private.
.It Dv MAP_SHARED
Modifications are shared.
.It Dv MAP_TRYFIXED
Attempt to use the hint provided by
.Fa addr .
This is the default mapping type and need not be specified.
Use of
.Dv MAP_TRYFIXED
is discouraged, as it is a non-portable extension.
.It Dv MAP_COPY
Modifications are private and, unlike
.Dv MAP_PRIVATE ,
modifications made by others are not visible.
This option is deprecated, shouldn't be used and behaves just like
.Dv MAP_PRIVATE
in the current implementation.
.El
.Pp
The
.Xr close 2
function does not unmap pages; see
.Xr munmap 2
for further information.
.Sh RETURN VALUES
Upon successful completion,
.Nm mmap
returns a pointer to the mapped region.
Otherwise, a value of
.Dv MAP_FAILED
is returned and
.Va errno
is set to indicate the error.
The symbol
.Dv MAP_FAILED
is defined in the header
.Ao Pa sys/mman.h Ac .
A successful return from
.Nm
will never return the value
.Dv MAP_FAILED .
.Sh ERRORS
.Nm
will fail if:
.Bl -tag -width Er
.It Bq Er EACCES
The flag
.Dv PROT_READ
was specified as part of the
.Fa prot
parameter and
.Fa fd
was not open for reading.
The flags
.Dv MAP_SHARED
and
.Dv PROT_WRITE
were specified as part
of the
.Fa flags
and
.Fa prot
parameters and
.Fa fd
was not open for writing.
.It Bq Er EBADF
.Fa fd
is not a valid open file descriptor.
.It Bq Er EINVAL
.Dv MAP_FIXED
was specified and the
.Fa addr
parameter was not page aligned.
.It Bq Er EINVAL
.Fa addr
and
.Fa len
specified a region that would extend beyond the end of the address space.
.It Bq Er EINVAL
.Fa fd
did not reference a regular or character special file.
.It Bq Er EINVAL
The allocation
.Fa len
was 0.
.It Bq Er ENOMEM
.Dv MAP_FIXED
was specified and the
.Fa addr
parameter wasn't available.
.Dv MAP_ANON
was specified and insufficient memory was available.
.El
.Sh SEE ALSO
.Xr madvise 2 ,
.Xr mincore 2 ,
.Xr mlock 2 ,
.Xr mprotect 2 ,
.Xr mquery 2 ,
.Xr msync 2 ,
.Xr munmap 2 ,
.Xr getpagesize 3
.Sh BUGS
Due to a limitation of the current vm system (see
.Xr uvm 9 ) ,
mapping descriptors
.Dv PROT_WRITE
without also specifying
.Dv PROT_READ
is useless
(results in a segmentation fault when first accessing the mapping).
This means that such descriptors must be opened with
.Dv O_RDWR ,
which requires both read and write permissions on the underlying
object.
